<?php
/******************************************************************************/

/******************************************************************************/

class p_karma_reason extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        $this->info['plugin']      = 'p_karma_reason';
        $this->info['title']       = 'Karma Reason';
        $this->info['description'] = 'Добавляет поле ввода сообщения при голосовании за карму';
        $this->info['author']      = 'lokanaft';
        $this->info['version']     = '0.1b';

        $this->events[] = 'GET_USERS_ACTION_VOTEKARMA';
        $this->events[] = 'GET_USERS_ACTION_KARMA';
        $this->events[] = 'GET_USERS_ACTION_PROFILE';
        
        $this->config['Название окна причины'] = 'Сообщение';
        $this->config['Поясняющий текст'] = 'Введите причину: (минимальная длина 5 символов)';
        $this->config['Причина по умолчанию'] = '';
        $this->config['Минимальная длина причины'] = 5;
        $this->config['Сообщение об ошибке'] = 'Сообщение не должно быть короче 5 символов!';
        $this->config['Минимальная карма для плюса (0 - значит ноль минимум)'] = 0;
        $this->config['Название окна ошибки для плюса'] = 'Ошибка!';
        $this->config['Сообщение о низкой карме для плюса'] = 'У вас должно быть минимум 0 кармы!';
        $this->config['Минимальная карма для минуса'] = 0;
        $this->config['Название окна ошибки для минуса'] = 'Ошибка!';
        $this->config['Сообщение о низкой карме для минуса'] = 'У вас должно быть минимум 0 кармы!';
        
    }

    public function __get($name){
        switch($name){
            case 'inUser':
                return $this->inUser = cmsUser::getInstance();
            case 'model':
                cmsCore::loadModel('users');
                return $this->model = new cms_model_users();
            case 'can_plus':
                return $this->can_plus = ((string)$this->config['Минимальная карма для плюса (0 - значит ноль минимум)'] === '' ||
                        $this->inUser->karma >= $this->config['Минимальная карма для плюса (0 - значит ноль минимум)']);
            case 'can_minus':
                return $this->can_minus = ((string)$this->config['Минимальная карма для минуса'] === '' || 
                        $this->inUser->karma >= $this->config['Минимальная карма для минуса']);
        }
    }

// ==================================================================== //

    public function install(){
        parent::install();
        
        if(!$this->inDB->isFieldExists('cms_user_karma', 'reason'))
            $this->inDB->query('ALTER TABLE `cms_user_karma` ADD `reason` TEXT NOT NULL');

    }

// ==================================================================== //

    public function execute($event, $data){

        parent::execute();

        switch ($event){
            case 'GET_USERS_ACTION_VOTEKARMA': return $this->eventGetVoteKarma();
            case 'GET_USERS_ACTION_KARMA': return $this->eventGetKarma();
            case 'GET_USERS_ACTION_PROFILE': return $this->eventGetProfile();
        }

        return $data;

    }

// ==================================================================== //

    private function eventGetProfile() {
        
?>
    <script type="text/javascript">
            $(function(){
                        
                users.changeKarma = function(to_user_id, sign) {
                    $('.sess_messages').fadeOut();
<?php if(!$this->can_plus){ ?>
                    if(sign == 'plus'){
                        core.alert('<?php echo $this->config['Сообщение о низкой карме для плюса'];?>', '<?php echo $this->config['Название окна ошибки для плюса'];?>', null);
                        return;
                    }
<?php } ?>
<?php if(!$this->can_minus){ ?>
                    if(sign == 'minus'){
                        core.alert('<?php echo $this->config['Сообщение о низкой карме для минуса'];?>', '<?php echo $this->config['Название окна ошибки для минуса'];?>', null);
                        return;
                    }
<?php } ?>
<?php if($this->can_minus || $this->can_plus){ ?>
                    core.prompt('<?php echo $this->config['Поясняющий текст'];?>', '<?php echo $this->config['Причина по-умолчанию'];?>', '<?php echo $this->config['Название окна причины'];?>', function(msg) {
                        if($('#error_mess').length < 1)$("#popup_message").append('<div style="margin:6px 0;display:none" class="sess_messages"><div class="message_error" id="error_mess"><?php echo $this->config['Сообщение об ошибке'];?></div></div>');
                        if (!msg.length < <?php echo $this->config['Минимальная длина причины'];?>) {
                            $.post('/users/karma/'+sign+'/'+to_user_id, {reason: msg}, function(result){
                                if(result.error == false){
                                    core.box_close();
                                    $("#u_karma_cont").removeClass();
                                    $(".sign_link a").hide();
                                    if(result.data >= 0)$("#u_karma_cont").addClass('value-positive');
                                    else $("#u_karma_cont").addClass('value-negative');
                                    $("#u_karma").html(result.data).fadeOut().fadeIn();
                                }else{
                                    $('.sess_messages').fadeIn();
                                    $('#popup_prompt').focus();
                                }
                            }, 'json');
                        }else{
                            $('.sess_messages').fadeIn();
                            $('#popup_prompt').focus();
                        }
                    })
<?php } ?>
                }

            })
    </script>
<?php
        return false;
        
    }
    
    private function eventGetVoteKarma() {

        if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') { cmsCore::halt(); }

        if (!$this->inUser->id){ cmsCore::halt(); }

        $points = (cmsCore::request('sign', 'str', 'plus')=='plus' ? 1 : -1);
        $to     = cmsCore::request('to', 'int', 0);
        $reason = cmsCore::request('reason', 'str', '');
        if(!$to || mb_strlen($reason) < $this->config['Минимальная длина причины'] || (!$this->can_plus && $points > 0) || (!$this->can_minus && $points < 0)){
            cmsCore::jsonOutput(array('error' => true));
        }

        $user = cmsUser::getShortUserData($to);
        if (!$user) { cmsCore::halt(); }

        if (!$this->model->isUserCanChangeKarma($to)){ cmsCore::halt(); }

        cmsCore::jsonOutput(array('error' => false, 'data' => $this->changeKarmaUser($to, $points, $reason)));
        
        return true;

    }

    private function eventGetKarma() {

        global $_LANG;
        
	if($this->inUser->id){$this->inPage->addHeadJS('components/users/js/profile.js');}
        
        $id = cmsCore::request('id', 'int', 0);
        $usr = cmsUser::getShortUserData($id);
        if (!$usr) { cmsCore::error404(); }
	$pagetitle = $this->inCore->menuTitle();
	$pagetitle = ($pagetitle && $this->inCore->isMenuIdStrict()) ? $pagetitle : $_LANG['USERS'];
	$this->inPage->addPathway($pagetitle, '/users');
        
        $this->inPage->setTitle($_LANG['KARMA_HISTORY'].' — '.$usr['nickname']);
        $this->inPage->setDescription($_LANG['KARMA_HISTORY'].' '.$_LANG['USER2'].' '.$usr['nickname']);
        $this->inPage->addPathway($usr['nickname'], cmsUser::getProfileURL($usr['login']));
        $this->inPage->addPathway($_LANG['KARMA_HISTORY']);

        $smarty = $this->inCore->initSmarty('plugins', 'p_karma_reason.tpl');
        $smarty->assign('karma', $this->model->getUserKarma($usr['id']));
        $smarty->assign('usr', $usr);
        $smarty->display('p_karma_reason.tpl');
        
        return true;

    }

// ==================================================================== //
    
    private function changeKarmaUser($user_id, $points, $reason){

        $this->inDB->query("INSERT INTO cms_user_karma (user_id, sender_id, points, senddate, reason) VALUES ('{$user_id}', '{$this->inUser->id}', '{$points}', NOW(), '{$reason}')");
        $user_karma = cmsUser::getKarma($user_id);
        $this->inDB->query("UPDATE cms_user_profiles SET karma = '$user_karma' WHERE user_id = '$user_id'");
        cmsUser::checkAwards($user_id);
        return $user_karma;

    }

}

?>
